/*****************************************************************************/
/*
                                    ago.c


COPYRIGHT
---------
Copyright (C) 2008-2011 Mark G.Daniel
This program, comes with ABSOLUTELY NO WARRANTY.
This is free software, and you are welcome to redistribute it under the
conditions of the GNU GENERAL PUBLIC LICENSE, version 3, or any later version.


VERSION HISTORY
---------------
05-JAN-2007  MGD  initial
*/

/*****************************************************************************/

#ifdef VWCMS_VMS_V62
#undef _VMS_V6_SOURCE
#define _VMS_V6_SOURCE
#undef __VMS_VER
#define __VMS_VER 60200000
#undef __CRTL_VER
#define __CRTL_VER 60200000
#endif

#ifndef __VAX
#   pragma nomember_alignment
#endif

/* standard C header files */
#include <ctype.h>
#include <errno.h>
#include <stdio.h>
#include <stdlib.h>
#include <string.h>

/* VMS related header files */
#include <libdef.h>
#include <libdtdef.h>
#include <lib$routines.h>
#include "ssdef.h"
#include "stsdef.h"

/* application header file */
#include "cgilib.h"
#include "ago.h"
#include "config.h"
#include "other.h"
#include "vwcms.h"

#ifndef uchar
#define uchar unsigned char
#endif
#ifndef ushort
#define ushort unsigned short
#endif
#ifndef uint
#define uint unsigned int
#endif
#ifndef ulong
#define ulong unsigned long
#endif

#define FI_LI "AGO", __LINE__

/* global storage */

char *AgoLang [AGO_LANG_AGO+1];
char *AgoLangPtr,
     *AgoLangEn;

/* prototypes */

int sys$gettim (__unknown_params);

/* external storage */

extern BOOL  Debug,
             WatchEnabled;

extern char  *CgiScriptNamePtr;

extern char  SoftwareId[],
             Utility[],
             LoginUserName[];

extern CONFIG_DATA  VWcmsConfig;

/*****************************************************************************/
/*
Given a date/time in a standard VMS or RFC string format calculate how far that
is in days/hours/minutes from current time and return a pointer to a string
describing that.
*/

char* AgoWas (char *TimeStr)

{
   static unsigned long  LibDeltaDays = LIB$K_DELTA_DAYS,
                         LibDeltaHours = LIB$K_DELTA_HOURS,
                         LibDeltaMinutes = LIB$K_DELTA_MINUTES;
   int  len, status;
   unsigned long  DeltaDays,
                  DeltaHours,
                  DeltaMinutes;
   unsigned long  CurrentBinTime [2],
                  ResultBinTime [2],
                  WhenBinTime [2];
   char  *cptr;
   char  WhenStr [128];
   $DESCRIPTOR (TimeStrDsc, TimeStr);

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "AgoWas() |%s|\n", TimeStr);

   sys$gettim (&CurrentBinTime);

   AgoLangInit (CONFIG_LANG(LangAgo));

   for (cptr = TimeStr; *cptr && *cptr != '-'; *cptr++);
   if (!*cptr)
   {
      cptr = TimeStr;
      if (*cptr == ' ') *cptr++ = '0';
      while (isdigit(*cptr)) cptr++;
      while (*cptr == ' ') *cptr++ = '-';
      while (isalpha(*cptr)) cptr++;
      while (*cptr == ' ') *cptr++ = '-';
      while (isdigit(*cptr)) cptr++;
      while (*cptr) cptr++;
   }
   else
      while (*cptr) cptr++;

   TimeStrDsc.dsc$w_length = cptr - TimeStr;
   status = lib$convert_date_string (&TimeStrDsc, &WhenBinTime,
                                     0, 0, 0, 0);
   if (VMSnok (status)) return ("ERROR lib$convert_date_string()");

   status = lib$sub_times (&CurrentBinTime, &WhenBinTime, &ResultBinTime);
   if (status == LIB$_NEGTIM) return ("ERROR future");
   if (VMSnok (status)) return ("ERROR lib$sub_times()");

   status = lib$cvt_from_internal_time (&LibDeltaDays, &DeltaDays,
                                        &ResultBinTime);
   if (VMSnok (status)) return ("ERROR lib$cvt_from_internal_time(days)");

   status = lib$cvt_from_internal_time (&LibDeltaHours, &DeltaHours,
                                        &ResultBinTime);
   if (VMSnok (status)) return ("ERROR lib$cvt_from_internal_time(hours)");

   status = lib$cvt_from_internal_time (&LibDeltaMinutes, &DeltaMinutes,
                                        &ResultBinTime);
   if (VMSnok (status)) return ("ERROR lib$cvt_from_internal_time(minutes)");

   DeltaMinutes -= DeltaHours * 60;
   DeltaHours -= DeltaDays * 24;

   if (DeltaDays >= 365)
      len = sprintf (WhenStr, "%d %s %s",
                     DeltaDays / 365,
                     (DeltaDays / 365) == 1 ?
                         AgoLang[AGO_LANG_YEAR] :
                         AgoLang[AGO_LANG_YEARS],
                     AgoLang[AGO_LANG_AGO]);
   else
   if (DeltaDays >= 60)
      len = sprintf (WhenStr, "%d %s %s",
                     DeltaDays / 30,
                     AgoLang[AGO_LANG_MONTHS],
                     AgoLang[AGO_LANG_AGO]);
   else
   if (DeltaDays >= 14)
      len = sprintf (WhenStr, "%d %s %s",
                     DeltaDays / 7,
                     AgoLang[AGO_LANG_WEEKS],
                     AgoLang[AGO_LANG_AGO]);
   else
   if (DeltaDays >= 2)
      len = sprintf (WhenStr, "%d %s %s",
                     DeltaDays,
                     AgoLang[AGO_LANG_DAYS],
                     AgoLang[AGO_LANG_AGO]);
   else
   if (DeltaDays && DeltaHours)
      len = sprintf (WhenStr, "%d %s %d %s %s",
                     DeltaDays,
                     DeltaDays == 1 ?
                         AgoLang[AGO_LANG_DAY] :
                         AgoLang[AGO_LANG_DAYS],
                     DeltaHours,
                     DeltaHours == 1 ? 
                         AgoLang[AGO_LANG_HOUR] :
                         AgoLang[AGO_LANG_HOURS],
                     AgoLang[AGO_LANG_AGO]);
   else
   if (DeltaDays)
      len = sprintf (WhenStr, "%d %s %s",
                     DeltaDays,
                     DeltaDays == 1 ?
                         AgoLang[AGO_LANG_DAY] :
                         AgoLang[AGO_LANG_DAYS],
                     AgoLang[AGO_LANG_AGO]);
   else
   if (DeltaHours)
      len = sprintf (WhenStr, "%d %s %s",
                     DeltaHours,
                     DeltaHours == 1 ?
                         AgoLang[AGO_LANG_HOUR] :
                         AgoLang[AGO_LANG_HOURS],
                     AgoLang[AGO_LANG_AGO]);
   else
   if (DeltaMinutes)
      len = sprintf (WhenStr, "%d %s %s",
                     DeltaMinutes,
                     DeltaMinutes == 1 ?
                         AgoLang[AGO_LANG_MINUTE] :
                         AgoLang[AGO_LANG_MINUTES],
                     AgoLang[AGO_LANG_AGO]);
   else
      len = sprintf (WhenStr, "%s", AgoLang[AGO_LANG_JUST_NOW]);

   cptr = CgiLibVeeMemCalloc (len);
   if (!cptr) exit (vaxc$errno);
   strcpy (cptr, WhenStr);

   return (cptr);
}

/*****************************************************************************/
/*
Initialise the ago language array.
*/

void AgoLangInit (char *AgoLangString)

{
   int  idx, len;
   char  *cptr, *sptr;

   /*********/
   /* begin */
   /*********/

   if (Debug) fprintf (stdout, "AgoLangInit()\n");

   if (AgoLangString && AgoLangString[0])
   {
      /* verify the elements in the ago language string */
      idx = 0;
      for (cptr = AgoLangString; *cptr; cptr++)
         if (*cptr == '|') idx++;
      if (idx != AGO_LANG_AGO)
      {
         if (WatchEnabled) WatchThis (FI_LI, "ERROR: !AZ", AgoLangString);
         /* fall back to using the English language one */
         AgoLangString = AgoLangEn;
      }
   }

   len = strlen(AgoLangString);
   AgoLangPtr = CgiLibVeeMemCalloc (len);
   if (!AgoLangPtr) ErrorExit (vaxc$errno, FI_LI);
   memcpy (cptr = AgoLangPtr, AgoLangString, len);

   /* we've already checked for a correct fit */
   for (idx = 0; idx < AGO_LANG_AGO+1; idx++)
   {
      for (sptr = cptr; *sptr && *sptr != '|'; sptr++);
      if (*sptr) *sptr++ = '\0';
      AgoLang[idx] = cptr;
      cptr = sptr;
   }
}

/*****************************************************************************/

