/******************************************************************************/
/*
                                   login.h
*/
/******************************************************************************/

#ifndef INCLUDE_LOGIN_H
#define INCLUDE_LOGIN_H

#define LOGIN_USERNAME_SIZE 95

#define LOGIN_VERIFY_SECONDS_DEFAULT   5 * 60  /* five minutes */
#define LOGIN_IDLE_SECONDS_DEFAULT    60 * 60  /* sixty minutes */

#define LOGIN_VERIFY_OK    1
#define LOGIN_VERIFY_NONE  2
#define LOGIN_VERIFY_FAIL  3
#define LOGIN_VERIFY_IDLE  4

/* include plain-text credential WATCH statements (essential debug only) */
#define LOGIN_WATCH_CRED 0

/*************/
/* prototype */
/*************/

int LoginAgent (char*, char*, char*);
BOOL  LoginAlias (char**, char**);
BOOL LoginAuthUser (char*, char*, char*);
void LoginConfig ();
char* LoginGetSessionCookie (int*);
BOOL LoginInitial ();
BOOL LoginRestricted ();
void LoginSetSessionCookie (char*, int);
void LoginSetSession (char*, char*);
int LoginVerifyUser ();

#endif /* INCLUDE_LOGIN_H */

/******************************************************************************/

